use n::packet::*;

#[inline(always)]
pub fn extract_version_u8(packet : Packet) -> Packet {
	let mut packet = packet;
	let first_byte = packet.read_u8(0);
	packet.context.set_u8("ip::version_u8", (first_byte >> 4) & 0x0Fu8);
	packet
}

#[inline(always)]
pub fn extract_hop_limit(packet : Packet) -> Packet {
	let (mut packet,field) = packet.next_packet(1);
	packet.context.set_field("ip::hop_limit", field);
	packet
}

#[inline(always)]
pub fn extract_hop_limit_u8(packet : Packet) -> Packet {
    let mut packet = packet;
	let hop_limit;
	{
		let field = packet.context.get_field("ip::hop_limit");
		hop_limit = field.read_u8(0);
	}
	packet.context.set_u8("ip::hop_limit_u8", hop_limit);
	packet
}

#[inline(always)]
pub fn extract_total_length(packet : Packet) -> Packet {
	let (mut packet,field) = packet.next_packet(2);
	packet.context.set_field("ip::total_length", field);
	packet
}

#[inline(always)]
pub fn extract_total_length_u16(packet : Packet) -> Packet {
	let mut packet = packet;
	let length;
	{
		let field = packet.context.get_field("ip::total_length");
		length = field.read_u16(0);
	}
	packet.context.set_u16("ip::total_length_u16", length);
	packet
}

#[inline(always)]
pub fn extract_protocol(packet : Packet) -> Packet {
	let (mut packet,field) = packet.next_packet(1);
	packet.context.set_field_released("ip::protocol", field);
	packet
}

#[inline(always)]
pub fn extract_protocol_u8(packet : Packet) -> Packet {
	let mut packet = packet;
	let protocol;
	{
		let field = packet.context.get_field("ip::protocol");
		protocol = field.read_u8(0);
	}
	packet.context.set_u8_released("ip::protocol_u8", protocol);
	packet
}