use n::packet::*;

#[inline(always)]
pub fn extract_source(packet : Packet) -> Packet {
	let (mut packet,field) = packet.next_packet(2);
	packet.context.set_field("l4::source", field);
	packet
}

#[inline(always)]
pub fn extract_destination(packet : Packet) -> Packet {
	let (mut packet,field) = packet.next_packet(2);
	packet.context.set_field("l4::destination", field);
	packet
}

#[inline(always)]
pub fn extract_source_u16(packet : Packet) -> Packet {
    let mut packet = packet;
	let port;
	{
		let field = packet.context.get_field("l4::source");
		port = field.read_u16(0);
	}
	packet.context.set_u16("l4::source_u16", port);
	packet
}

#[inline(always)]
pub fn extract_destination_u16(packet : Packet) -> Packet {
    let mut packet = packet;
	let port;
	{
		let field = packet.context.get_field("l4::destination");
		port = field.read_u16(0);
	}
	packet.context.set_u16("l4::destination_u16", port);
	packet
}